#!/usr/bin/env python

# This is the HTCondor autoscaling script

__copyright__ = "Copyright 2016 Cycle Computing"
__maintainer__ = "Cycle Computing"

import os

def _get_jobs():
    cmd = 'condor_q -global -constraint "(JobStatus < 3) && (JobUniverse != 7) && (JobUniverse != 12)"'
    args = ['GlobalJobId', 'average_runtime', 'RequestCpus', 'slot_type']
    for arg in args:
        cmd += ' -format "%s" ' + arg
        cmd += ' -format "|" MyType'
    cmd += ' -format "\n" MyType'

    jobs = []
    output = os.popen(cmd)
    for line in output.readlines():
        line = line.strip()
        if line != '' and line != 'All queues are empty':
            rec = [x.strip() for x in line.split('|')]
            name = str(rec[0])
            slot_type = None
            required_cpus = None
            average_runtime = None
            if rec[1] != '':
                average_runtime = int(rec[1])        
            if rec[2] != '':
                required_cpus = int(rec[2])
            if rec[3] != '':
                slot_type = str(rec[3])
            jobs.append({
                'name': name,
                'nodearray': slot_type,
                'required_cpus': required_cpus,
                'average_runtime': average_runtime           
            })

    return jobs

if __name__ == "__main__":
    import jetpack.autoscale
    jetpack.autoscale.scale_by_jobs(_get_jobs())
