# Cookbook Name:: ccondor
# Recipe:: _poolpass_user_homes
#
# Copyright 2019, Microsoft
#
# All rights reserved - Do not Redistribute
#

# This is a bit of a hack for backwards compatibility.
# May want to eliminate condor poolpass setup in the future.

chefstate = node['cyclecloud']['chefstate']

# Calculate the basename of user homes
home_directories = Dir.glob(File.join(node['cuser']['base_home_dir'], '*', File::SEPARATOR)).collect { |h| File.basename(h) if File.directory?(h) }

# Walk the calculated user homes, setting up poolpass
home_directories.each do |cuser|
  user_home = File.join(node['cuser']['base_home_dir'], cuser)
  execute "#{cuser} pool pass" do
    command "test -f /root/.pool && cp -f /root/.pool #{user_home}/.pool && chmod 0400 #{user_home}/.pool && chown #{cuser}:#{cuser} #{user_home}/.pool && touch #{chefstate}/ccondor.#{cuser}.poolpass.done"
    not_if "test -f #{chefstate}/#{cuser}.poolpass.done"
    only_if "test -d #{user_home}"
    not_if { node['htcondor']['auth']['disable'] }
    action :run
  end
end
