#
# Cookbook Name:: cautostart
# Recipe:: default
#


bootstrap_dir = node['cyclecloud']['bootstrap']

if node[:os] == "windows"

  cookbook_file "#{bootstrap_dir}\\scaleup.py" do
    source "scaleup.py"
  end

  cookbook_file "#{bootstrap_dir}\\run_scaleup.bat" do
    source "run_scaleup.bat"
  end

  # setup cron w/ schtasks.exe
  taskname = "autostart_condor_scaleup"
  taskrun = "#{bootstrap_dir}\\run_scaleup.bat"
  schedule = "MINUTE"
  modifier = "1"

  cmd = "schtasks /Create /TN #{taskname} /SC #{schedule} /MO #{modifier} /F /RU \"System\" /TR #{taskrun}"
  execute "schtasks #{taskname}" do
    command cmd
    only_if { node['cyclecloud']['cluster']['autoscale']['start_enabled'] }
  end
else # linux
  cookbook_file "#{bootstrap_dir}/scaleup.py" do
    source "scaleup.py"
    if not node[:os] == "windows"
    owner "root"
    group "root"
    mode "0750"
    end
    action :create
  end

  scaleup_interval = "*"
  cron "autostart" do
    minute scaleup_interval
    command "#{bootstrap_dir}/cron_wrapper.sh #{bootstrap_dir}/scaleup.py"
    only_if { node['cyclecloud']['cluster']['autoscale']['start_enabled'] }
  end
end
