#
# Cookbook Name:: ccondor
# Recipe:: sched_config
#
# Copyright 2010, Cycle Computing
#
# All rights reserved - Do Not Redistribute
#
# NOTE : Currently DOES NOT support Windows
#

include_recipe "ccondor::default"
include_recipe "cyclecloud"
include_recipe "ccondor::scheduler"
include_recipe "ccondor::poolpass"

central_manager_internal_hostname = cluster.cm_hostname
scheduler_internal_hostname       = cluster.scheduler

data_dir = node[:htcondor][:data_dir]

if central_manager_internal_hostname == nil
  Chef::Log.error "CM unknown. Aborting converge."
  exit 1
else
  Chef::Log.info "CM: #{central_manager_internal_hostname}"
  Chef::Log.info "Sched: #{scheduler_internal_hostname}"
  if node[:os] == "windows"

    # Over-write local config generated by ccondor::sched_config
    template "#{data_dir}\\condor_config.local" do
      source "win-condor-config-local-unified-cm-sched.erb"
      variables(:central_manager_internal_hostname => central_manager_internal_hostname)
      rights :full_control, "Administrators"
      
      notifies :run, "execute[condor-reconfig]"
    end

    # allow everyone read,execute perms to condor_config.local
    execute "icacls #{data_dir}\\condor_config.local /grant Everyone:(RX)"
    
  else # linux

    # Over-write local config generated by ccondor::sched_config
    template "/mnt/condor_data/condor_config.cloud" do
      source "condor-config-local-unified-cm-sched.erb"
      mode "0644"
      owner "root"
      group "root"
      variables(:central_manager_internal_hostname => central_manager_internal_hostname)

      notifies :run, "execute[condor-reconfig]"

    end
  end
end
