include_recipe "cyclecloud"

package "glusterfs-client" do
  action :install
end

directory "/shared" do
  owner "root"
  group "root"
  mode "0755"
  action :create
end

directory "/sched" do
  owner "root"
  group "root"
  mode "0755"
  action :create
end

schedint = cluster.scheduler
if schedint == nil
  exit 1
else
  template "/etc/glusterfs.shared.vol" do
    source "glusterfs.shared.erb"
    variables({
      :glusterd1 => schedint
    })
  end
  mount "/shared" do
    device "/etc/glusterfs.shared.vol"
    fstype "glusterfs"
    options "defaults"
    action [:mount, :enable]
  end

  template "/etc/glusterfs.sched.vol" do
    source "glusterfs.sched.erb"
    variables({
      :glusterd1 => schedint
    })
  end
  mount "/sched" do
    device "/etc/glusterfs.sched.vol"
    fstype "glusterfs"
    options "defaults"
    action [:mount, :enable]
  end
end

