
clusterinit_dir = node[:cluster_init][:home_dir]
if clusterinit_dir.nil?
  # Handle varying Windows drive layouts for the cluster-init dir
  # If all else fails, put it on C:\\
  if node[:os] == "windows"
    %w{Z:\\ D:\\ C:\\}.each do |drive|
      if ::File.exist?(drive)
        clusterinit_dir = drive + 'cluster-init'
        break
      end
    end
  else
    clusterinit_dir = '/mnt/cluster-init'
  end

  node.default[:cluster_init][:home_dir] = clusterinit_dir
end

directory clusterinit_dir do
  recursive true
end

# Create a symlink from C:\\ so we can write consistent documentation
clusterinit_lnk = 'C:\\cluster-init'
link clusterinit_lnk do
  to clusterinit_dir
  only_if { node[:os] == 'windows' && !::File.exist?('C:\\cluster-init') }
end

include_recipe 'jetpack'
jetpack_cluster_init 'run cluster-init'
