# This returns an absolute path to a real directory, given a symlink.
# So that we can copy selinux file context to the correct path.
def follow_symlink(path)
  if ::File.exist?(path) &&
     ::File.symlink?(path)
    ::File.readlink(path)
  else
    path
  end
end

# Detect selinux status
# Duplicated from cyclecloud here, and cshared, to avoid declaring
# cyclical dependency on cyclecloud.
def selinux_enabled
  getenforce = ::File.exist?('/sys/fs/selinux/enforce') && ::File.read('/sys/fs/selinux/enforce').to_i == 1
  cyclecloud_policy = node['cyclecloud'].key?('selinux') && node['cyclecloud']['selinux'].key?('policy') && node['cyclecloud']['selinux']['policy'].downcase == 'enforcing'
  getenforce && cyclecloud_policy
end
