#
# Cookbook Name:: cuser
# Recipe:: default
#

require 'etc' 

cuser = node[:cyclecloud][:cluster][:user][:name]
mypass = node[:cyclecloud][:cluster][:user][:password]

if not node[:cyclecloud][:cluster][:user][:disabled].nil? and node[:cyclecloud][:cluster][:user][:disabled] == true
  log "Local Cluster User ( #{cuser} )creation disabled..." do
    level :warn
  end
  return
end

if node[:os] == "windows"
  user cuser do
    action :create
    password mypass
  end

  remote_desktop_user = cuser
  # returns 1 (error) if the computer is NOT domain joined 
  unless powershell_out("exit [int]((Get-WmiObject -class Win32_ComputerSystem).partOfDomain -eq $false)").error?
    remote_desktop_user = "#{ENV['USERDOMAIN']}\\#{cuser}"
  end
  group "Remote Desktop Users" do
    action :modify
    members [remote_desktop_user]
    append true
  end

else # linux
  # NOTE: Linux users are now managed by jetpackd, the daemon will look and add/disable/update keys for users when they are granted permissions to access
  # the cluster in CycleCloud.
end

# We will call initialize jetpack here to perform the intial round of usermanagement. 
# In the future we can hopefully move this earlier into `cyclecloud::default` and eventually out of chef but for now
# this is the most appropriate place to call it since it is where users were previously managed.
execute 'Initialize Jetpack' do
  command "#{node['cyclecloud']['home']}/system/embedded/bin/jetpack-initialize" if node[:os] == "linux"
  command "#{node['cyclecloud']['home']}/system/bin/jetpack-initialize.cmd" if node[:os] == "windows"
end
