# These are the defaults we use on a mountpoint hash

# Assume ext4 is a good enough default for everything
default['cyclecloud']['mount_defaults']['fs_type'] = 'ext4'

default[:cyclecloud][:mount_defaults][:size] = "100%"
default[:cyclecloud][:mount_defaults][:raid_level] = 0
default[:cyclecloud][:mount_defaults][:encryption][:bits] = nil
default[:cyclecloud][:mount_defaults][:chunk_size] = 64

default[:cvolume][:ebs_wait] = 300

case node['platform']
when 'ubuntu'
  default[:cvolume][:packages] = %w(lvm2 mdadm xfsprogs cryptsetup)
when 'centos', 'redhat'
  # Dropped CentOS 5 (xfsprogs xfsdump e4fsprogs kmod-xfs-xen)
  if node['platform_version'].to_i <= 6
    default[:cvolume][:packages] = %w(xfsprogs xfsdump cryptsetup-luks lvm2)
  elsif node['platform_version'].to_i >= 7
    default[:cvolume][:packages] = %w(xfsprogs xfsdump cryptsetup mdadm lvm2)
  end
else
  default[:cvolume][:packages] = []
end

# Key SUSE packages from platform family instead of platform since the SLES
# platform can now contain multiple versions of the HPC image sku
case node['platform_family']
when 'suse'
  default[:cvolume][:packages] = %w(xfsdump mdadm)
end
