action :create do

  # the regexes match `LogicalExtentsNumber[%{VG|PVS|FREE}]`
  # and LogicalVolumeSize[bBsSkKmMgGtTpPeE]
  def create_command
    size =
      case new_resource.size
      when /\d+[kKmMgGtT]/
        "--size #{new_resource.size}"
      when /(\d{1,2}|100)%(FREE|VG|PVS)/
        "--extents #{new_resource.size}"
      when /(\d+)/
        "--size #{$1}" # rubocop:disable PerlBackrefs
      end

    name = new_resource.name
    group = new_resource.group
    "lvcreate #{size} --name #{name} #{group}"
  end
  
  ruby_block "create lv for #{new_resource.name} in vg #{new_resource.group}" do
    block do
      cmd = Mixlib::ShellOut.new(create_command)
      cmd.run_command.error!
    end
    only_if do ! ::File.exist?("/dev/#{new_resource.group}/#{new_resource.name}") end
  end

end
