#!/bin/bash
#$ -S /bin/sh
#
# $1 is uuid generated by cycleserver
# $2 is the normalized, absolute path of the shared filesystem used for file transfer
# Optional: $3 is a namespace for the tickets (generally cluster name)
#

# Namespace may be empty for older submitonce installs
NAMESPACE=""
if [ -n "${3}" ]; then
    NAMESPACE="/${3}"
fi


PRESUBMIT_DIR=${2}/presubmit${NAMESPACE}/jobdir_${1}
TICKET_DIR=${2}/tickets${NAMESPACE}

TICKET_FILE=ticket_${1}_outgoing


# COPY THE INCOMING XFER TICKET FROM THE STAGING AREA INTO THE TICKET DIRECTORY
cp -f ${PRESUBMIT_DIR}/${TICKET_FILE} ${TICKET_DIR}/${TICKET_FILE}
chmod -R 777 ${TICKET_DIR}/${TICKET_FILE}

# WAIT FOR THE TICKET TO COMPLETE
while [ -f ${TICKET_DIR}/${TICKET_FILE} ]; do
  sleep 1
done
