Description
====
Libraries for use by CycleCloud cookbooks.

Requirements
====
"Chuck Norris will never have a heart attack. His heart isn't nearly foolish enough to attack him."  This cookbook doesn't depend on other cookbooks; other cookbooks depend on it.

Platform
----

Tested on:

  * Ubuntu 14.04, 16.04
  * CentOS 6.x, 7.x

Resources and Providers
====

defer_block
-----------

The defer_block helper allows you to defer a block of arbitrary ruby
code and Chef resources for execution at the end of the Chef run as a
[delayed notification]http://docs.opscode.com/resource_common_notifications.html). It
is important to consider that the queue of delayed notifications is a
FIFO queue, so you cannot guarantee that a given defer_block is
executed as the absolute last resource.


In the following example, the resources and variables inside the
`defer_block` block will be executed after the resources included with the
following `include_recipe`

```Ruby

package "condor"

template "condor_config" do
  source "condor.cfg.erb"
  owner "condor"
end

defer_block "windows_shite" do
  restart_file = "C:\\cycle\\jetpack\\system\\bootstrap\\condor_restarted"
  execute "touch_condor_restarted" do
    command "copy nul #{restart_file}"
    creates restart_file
  end

  execute "poolpass" do
    command "C:\\Condor\\bin\\condor_store_cred add -c -p condor_pool_key"
  end
end

include_recipe "cluster_init"

```


Attributes
====
