# Set automatically.  If true, indicates this node is running in VPC.
default['cyclecloud']['hosts']['is_vpc'] = false

# If true and in VPC, attempt basic emulation of DNS (should only be used to
# work around misconfigured DNS)
default['cyclecloud']['hosts']['simple_vpc_dns']['enabled'] = false

# Replaces the default EC2 assigned domain with the custom domain
default['cyclecloud']['hosts']['simple_vpc_dns']['suffix'] = ''

# If set and in VPC and assigning a custom DNS domain to the instances,
# Creates an additional hostname mapping for the custom domain
default['cyclecloud']['hosts']['simple_vpc_dns']['alt_suffix'] = ''

# If true, attempt basic emulation of DNS.  Required for MPI in Azure
# Does not work in GCE due to:
# https://git.cyclecomputing.com/internal/cyclecloud/issues/222
default['cyclecloud']['hosts']['standalone_dns']['enabled'] = node['cyclecloud']['instance']['provider'] == 'azure'

# List of additional subnets to enumerate in the hosts file (in addition to local subnet)
default['cyclecloud']['hosts']['standalone_dns']['subnets'] = []

# Replaces the default CSP assigned domain with the custom domain
default['cyclecloud']['hosts']['standalone_dns']['suffix'] = ''

# If set and in VPC and assigning a custom DNS domain to the instances,
# Creates an additional hostname mapping for the custom domain
default['cyclecloud']['hosts']['standalone_dns']['alt_suffix'] = ''

if node['cyclecloud']['hosts']['standalone_dns']['enabled']
  hex_hostname = ::CycleCloud::Helpers.to_hex(node['ipaddress'].to_s)
  default['cyclecloud']['instance']['hostname'] = if node['domain'].nil? || node['domain'].empty?
                                                    'ip-' + hex_hostname
                                                  else
                                                    'ip-' + hex_hostname + '.' + node['domain']
                                                  end
elsif (node['cyclecloud']['instance']['provider'] == 'ec2') && node['ec2']
  default['cyclecloud']['instance']['hostname'] = node['ec2']['hostname']
else
  default['cyclecloud']['instance']['hostname'] = node['hostname']
end

# If set, attempt to update DNS with new host domain
default['cyclecloud']['dns']['domain'] = nil

# If set (and domain set), attempt to create a CNAME alias for the host
# (NOTE: this should be the short name, not the fqdn for the alias)
default['cyclecloud']['dns']['alias'] = nil
