module CycleCloud
  class ProfilerHandler < Chef::Handler

    def report
      recipes = Hash.new(0)

      # collect all profiled timings and group by [cookbook, recipe]
      all_resources.each do |r|
        recipes[[r.cookbook_name, r.recipe_name]] += r.elapsed_time
      end

      Chef::Log.info('---- PROFILER DATA ----')
      total_time = 0
      recipes.sort_by { |_key, duration| -duration }.each do |key, duration|
        total_time += duration
        Chef::Log.info '%12f %s::%s' % [duration, key[0], key[1]]
      end
      Chef::Log.info("---- #{total_time} SECONDS ----")

      # TODO: Report metrics back to CycleCloud

    end
  end
end
