#!/usr/bin/env python
import sys
import json
import os

if os.name == 'nt':
    cyclecloud_home = os.getenv('CYCLECLOUD_HOME', 'C:\\cycle\\jetpack')
    CONFIG_FILE = cyclecloud_home + '\\config\\node.json'
else:
    cyclecloud_home = os.getenv('CYCLECLOUD_HOME', '/opt/cycle/jetpack')
    CONFIG_FILE = cyclecloud_home + '/config/node.json'

if len(sys.argv) < 2:
    print("Usage: get_config_val <value> [default]")
    print("Example: get_config_val foo.bar.baz")
    sys.exit(1)

def get_config_val(current_val, properties):
    for prop in properties:
        current_val = current_val[str(prop)]
    return current_val

properties = sys.argv[1].split(".")

default_value = None
if len(sys.argv) == 3:
    default_value = sys.argv[2]

f = open(CONFIG_FILE)
config = json.loads(f.read())

try:
    current_val = get_config_val(config, properties)
except KeyError as e:
    if default_value:
        print(default_value)
        sys.exit(0)
    else:
        print("KeyError: %s" % e)
        sys.exit(1)

print(current_val)
