
def defer_block(_name, &resource_block)
  require 'securerandom'
  block_no = ::SecureRandom.hex(3)
  this_recipe = self

  ruby_block "defer_block_#{block_no}" do
    block do
      this_recipe.instance_eval(&resource_block)
      run_context.resource_collection.iterator.send(:iterate)
    end
    action :nothing
  end

  ruby_block 'notify_block' do
    block do
      puts 'notifying deferred block'
    end
    notifies :create, "ruby_block[defer_block_#{block_no}]", :delayed
  end
end
