#
# Cookbook Name:: cyclecloud
# Recipe:: _first
#
# Copyright 2015, CYCLE COMPUTING LLC
#
# All rights reserved - Do Not Redistribute
#
# this comment added from a PLANE

# http://tickets.opscode.com/browse/CHEF-2224
node.save unless Chef::Config['solo']

Chef::Log.info "Using CycleCloud cookbook version: #{node['cyclecloud']['cookbooks']['version']}"
Chef::Log.info "Using Jetpack version: #{node['cyclecloud']['jetpack']['version']}"

# @deprecated in 8.0
#include_recipe 'cyclecloud::_legacy_bootstrap_cleanup'

directory node['cyclecloud']['chefstate'] do
  unless node['os'] == 'windows'
    owner 'root'
    group 'root'
    mode '0700'
  end
  action :create
  recursive true
end

include_recipe 'cyclecloud::_limits'

# @deprecated in 8.0, its not even the right filename
# Turn off mlocate asap because...
#file '/etc/cron.daily/mlocate.cron' do
#  action :delete
#  not_if { node['os'] == 'windows' }
#end

# @deprecated in 8.0
#include_recipe 'cyclecloud::_hyperthreading'
#include_recipe 'cyclecloud::_sudo'

# Ensure that yum is installed if we're RHEL like
# NOTE: If using this public mirror is an issue, we can install Cycle mirrors instead.

unless node['os'] == 'windows'
  include_recipe 'cvolume' # Replaces cephemeral AND cebs
  include_recipe 'cshared'
end

include_recipe 'cyclecloud::_hosts'

# Make a /mnt/scratch directory - Used to be in cephemeral
# TODO: Why do we do this here? Find a better place for it
directory '/mnt/scratch' do
  unless node['os'] == 'windows'
    owner 'root'
    group 'root'
    mode '1777'
  end
  not_if { node['os'] == 'windows' }
  action :create
end

include_recipe 'cyclecloud::_apt'
