require 'spec_helper'

shared_examples "::default 8.0.0 cleanup" do |platform, version|
  context "On #{platform} #{version}" do
    cached(:chef_run) do
      ChefSpec::ServerRunner.new(platform: platform, version: version).converge(described_recipe)
    end

    %w(
      cyclecloud::_yum_cache
      cyclecloud::_fail2ban
      cyclecloud::_firewall
      cyclecloud::_devices
      cyclecloud::_legacy_bootstrap_cleanup
      cyclecloud::_legacy_autostop_callback
      cyclecloud::_hyperthreading
      cyclecloud::_sudo
      cyclecloud::_swap
      cyclecloud::_time
      cyclecloud::_openlogic_failsafe
      cyclecloud::_compatibility
      cyclecloud::_motd
    ).each do |recipe|
      it "does not include #{recipe}" do
        expect(chef_run).to_not include_recipe(recipe)
      end
    end

    it 'converges successfully' do
      expect { chef_run }.to_not raise_error
    end
  end
end

describe 'cyclecloud::default' do
  platforms = {
    'centos' => ['6.9', '7.4.1708'],
    'ubuntu' => ['14.04', '16.04'],
  }

  platforms.each do |platform, versions|
    versions.each do |version|
      it_behaves_like '::default 8.0.0 cleanup', platform, version
    end
  end
end
