require 'spec_helper'

describe 'cyclecloud::_legacy_bootstrap_cleanup' do
  context 'cycle_bootstrap script exists' do
    cached(:chef_run) do
      ChefSpec::ServerRunner.new(platform: 'centos', version: '7.4.1708').converge(described_recipe)
    end

    before do
      allow(::File).to receive(:exist?).and_call_original
      allow(::File).to receive(:exist?).with('/etc/init.d/cycle_bootstrap').and_return true
    end

    it 'stops and disables cycle_bootstrap' do
      expect(chef_run).to stop_service('cycle_bootstrap')
      expect(chef_run).to disable_service('cycle_bootstrap')
    end

    it 'delete /etc/init.d/cycle_bootstrap' do
      expect(chef_run).to delete_file('/etc/init.d/cycle_bootstrap')
    end

    it 'converges successfully' do
      expect { chef_run }.to_not raise_error
    end
  end
end
