require 'spec_helper'

shared_examples "_openlogic_failsafe" do |platform, version|
  context "On #{platform} #{version}" do
    cached(:chef_run) do
      ChefSpec::ServerRunner.new(platform: platform, version: version).converge(described_recipe)
    end

    # There is no matcher for replace_or_add in line cookbook
    it 'converges successfully' do
      expect { chef_run }.to_not raise_error
    end
  end
end

describe 'cyclecloud::_openlogic_failsafe' do
  platforms = {
    'centos' => ['7.4.1708'],
  }

  platforms.each do |platform, versions|
    versions.each do |version|
      it_behaves_like '_openlogic_failsafe', platform, version
    end
  end
end
