require 'spec_helper'

describe 'cyclecloud::_passwd' do
  context 'Standard setup' do
    cached(:chef_run) do
      ChefSpec::SoloRunner.new(platform: 'centos', version: '6.9') do |node|
        node.automatic['etc']['passwd'] = { 'content' => 'exists' }
        node.automatic['etc']['group'] = { 'content' => 'exists' }
      end.converge('cyclecloud::_passwd')
    end

    it 'empties the etc key' do
      expect(chef_run.node['etc']['passwd']).to eq({})
      expect(chef_run.node['etc']['group']).to eq({})
    end
  end
  context 'Ohai plugin disabled' do
    cached(:chef_run) do
      ChefSpec::SoloRunner.new(platform: 'centos', version: '6.9') do |node|
        node.automatic['etc'] = nil # 'etc' will be nil if the plugin is gone
      end.converge('cyclecloud::_passwd')
    end

    it 'has no etc attribute' do
      expect(chef_run.node['etc']).to eq(nil)
    end
  end
end
