require 'spec_helper'

describe 'cyclecloud::_thunderball' do
  context 'custom configuration' do
    cached(:chef_run) do
      ChefSpec::SoloRunner.new(platform: 'centos', version: '6.9') do |node|
        node.automatic['cyclecloud']['thunderball']['config']['custom1']['access_key'] = 'a'
        node.automatic['cyclecloud']['thunderball']['config']['custom1']['secret_key'] = 'b'
        node.automatic['cyclecloud']['thunderball']['config']['custom1']['base'] = 'az://foo-bar-baz'
        node.automatic['cyclecloud']['thunderball']['config']['custom2']['access_key'] = 'c'
        node.automatic['cyclecloud']['thunderball']['config']['custom2']['secret_key'] = 'd'
        node.automatic['cyclecloud']['thunderball']['config']['custom2']['base'] = 'az://foo-bar-booz'
        node.automatic['cyclecloud']['thunderball']['config']['custom3']['type'] = 'az'
        node.automatic['cyclecloud']['thunderball']['config']['custom3']['sas_token'] = 'stok'
        node.automatic['cyclecloud']['thunderball']['config']['custom3']['base'] = 'az://foo-bar-beep'
        node.automatic['cyclecloud']['thunderball']['config']['custom4']['type'] = 'az'
        node.automatic['cyclecloud']['thunderball']['config']['custom4']['access_key'] = 'akey'
        node.automatic['cyclecloud']['thunderball']['config']['custom4']['base'] = 'az://foo-bar-boop'
      end.converge('cyclecloud::_thunderball')
    end

    it 'creates custom config' do
      expect(chef_run).to config_thunderball('custom1').with(
        username: 'a',
        password: 'b',
        default_region: nil,
        base: 'az://foo-bar-baz'
      )
      expect(chef_run).to config_thunderball('custom2').with(
        username: 'c',
        password: 'd',
        default_region: nil,
        base: 'az://foo-bar-booz'
      )
      expect(chef_run).to config_thunderball('custom3').with(
        type: 'az',
        sas_token: 'stok',
        default_region: nil,
        base: 'az://foo-bar-beep'
      )
      expect(chef_run).to config_thunderball('custom4').with(
        type: 'az',
        access_key: 'akey',
        default_region: nil,
        base: 'az://foo-bar-boop'
      )
    end
  end
end
