require 'spec_helper'

describe 'jdk::default' do

  platforms = {
    'ubuntu' => ['14.04', '16.04'],
    'centos' => ['6.8', '7.4.1708']
  }

  platforms.each do |platform, versions|
    versions.each do |version|
      context "On #{platform} #{version}" do
        cached(:chef_run) do
          ChefSpec::SoloRunner.new(platform: platform, version: version) do |node|
          end.converge(described_recipe)
        end

        it 'sets sane defaults' do
          expect(chef_run.node.default['java']['jdk_version']).to eq('8')
          expect(chef_run.node.default['java']['accept_license_agreement']).to eq(true)
          expect(chef_run.node.default['java']['oracle']['accept_oracle_download_terms']).to eq(false)
          expect(chef_run).to include_recipe('java::openjdk')
          expect(chef_run).to_not include_recipe('java::oracle')
          expect(chef_run).to_not include_recipe('java::oracle_rpm')
        end

      end
    end
  end
end

