#
# Cookbook Name:: jetpack
#
# Copyright 2015, Cycle Computing LLC
#
# All rights reserved - Do Not Redistribute
#

# Usage: jetpack log [OPTIONS] MESSAGE

#   Sends log message to CycleCloud

# Options:
#   -l, --level [info|warn|error]   Type of log message you wish to send.
#                                   Default: info
#   -p, --priority [low|medium|high]
#                                   Priority of message to send to CycleCloud.
#                                   Default depends on the level chosen. Info
#                                   messages get a priority of 'medium', warn
#                                   messages 'medium', and error messages 'high'
#   --help                          Show this message and exit.

action :log do

  message = "#{new_resource.message}"
  level = "-l #{new_resource.level}"
  priority = ""
  if not new_resource.priority.nil? and not new_resource.priority.empty?
    priority = "-p #{new_resource.priority}"
  end

  Chef::Log.info "Log: #{node['cyclecloud']['jetpack']['executable']} log #{level} #{priority} #{message}"
  execute "#{node['cyclecloud']['jetpack']['executable']} log #{level} #{priority} '#{message}'"
  new_resource.updated_by_last_action(true)
end
