#
# Cookbook Name:: jetpack
# Recipe:: default
#
# Copyright (C) 2015,  Cycle Computing
#
# All rights reserved - Do Not Redistribute
#

file "/tmp/jetpack_test" do
  action :touch
end

Chef::Log.info "Testing jetpack_log"
jetpack_log "This is a message from JetPack Test!" do
  level "warn"
end

Chef::Log.info "Testing jetpack_send"
jetpack_send "jetpack send simple message from jetpack test" do
  routing_key "benchmark.results"
end

Chef::Log.info "Testing jetpack_send block"
jetpack_send "Jetpack Send block test" do
  content <<-EOH
    { 'msg': 'jetpack send from jetpack test',
      'foo': 'bar' }
  EOH
  routing_key "benchmark.results"
  notifies :delete, 'file[jetpack_test]', :immediately
end

file 'jetpack_test' do
  path "/tmp/jetpack_test"
  action :nothing
end
