require 'spec_helper'

describe 'samba::default' do
  context "basic test" do
    cached(:chef_run) do
      ChefSpec::SoloRunner.new(:platform => 'centos', :version => '6.8') do |node|
      end.converge("samba::default")
    end

    it "installs packages" do
      expect(chef_run).to install_package('samba')
      expect(chef_run).to install_package('samba-client')
    end

    it 'enables and starts the samba service' do
      expect(chef_run).to enable_service('smb').with(supports: {:restart=>true})
      expect(chef_run).to start_service('smb').with(supports: {:restart=>true})
    end
  end
end
