require "json"

# Ohai plugin that ensures that decrypted userdata gets into the node object
# under ec2.userdata namespace (node[:ec2][:userdata]). This is ec2 specific, but
# will run on other providers for backwards compatibility purposes between providers.
Ohai.plugin(:CycleCloud) do
  depends "ec2"
  provides "ec2"

  collect_data do
    case RUBY_PLATFORM
    when /mswin|mingw32|windows/
      cyclecloud_home  = 'C:\\cycle\\jetpack'
    else
      cyclecloud_home  = '/opt/cycle/jetpack'
    end

    user_data_file = File.join(cyclecloud_home, 'config', 'user-data.json')
    if File.exist?(user_data_file)
      ec2 Mash.new if ec2.nil?
      ec2[:userdata] = JSON.parse(File.read(user_data_file))
    end
  end
end
