log_level              :info
log_location           STDOUT
verbose_logging	       false
file_cache_path        "/opt/cycle/jetpack/system/chef/cache"
file_backup_path       "/opt/cycle/jetpack/system/chef/backup"
json_attribs           "/opt/cycle/jetpack/system/chef/client-config.json"
cookbook_path          ["/opt/cycle/jetpack/system/chef/chef-repo/cookbooks"]
role_path              "/opt/cycle/jetpack/system/chef/chef-repo/roles"
data_bag_path          "/opt/cycle/jetpack/system/chef/chef-repo/data_bags"
ssl_verify_mode        :verify_peer

cache_options({ :path => "/opt/cycle/jetpack/system/chef/cache/checksums", :skip_expires => true})

Mixlib::Log::Formatter.show_time = true

enforce_path_sanity true

# This is disabled so the passwd Ohai plugin doesn't choke on LDAP/Samba servers.
# May want to add something to toggle it conditionally, later.
ohai.disabled_plugins = ['passwd']
ohai.plugin_path << '/opt/cycle/jetpack/system/chef/ohai/plugins'

# Add the exception reporting handler
require '/opt/cycle/jetpack/system/chef/handlers/cyclecloud_exception_handler'
exception_handler = CycleCloud::ExceptionHandler.new
exception_handlers << exception_handler