#
# Copyright:: Copyright (c) Chef Software Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require_relative "default_paths"

module ChefUtils
  module DSL
    module PathSanity
      include ChefUtils::DSL::DefaultPaths

      def sanitized_path(env = nil)
        default_paths(env)
      end

      private

      def __sane_paths
        __default_paths
      end

      extend self
    end
  end
end
