# Backwards compatibility hack
default['htcondor'] = ::Mash.new(node['ccondor'].to_hash) if node.key?('ccondor') && !node.key?('htcondor')

# set this value to use a custom package
default['htcondor']['package'] = nil

default['htcondor']['version'] = "8.6.11"

default['htcondor']['auth']['disable'] = false

default['htcondor']['negotiator_cycle_delay'] = 20

default['htcondor']['negotiator_interval'] = 60

default['htcondor']['negotiator_inform_startd'] = 'True'

# Set the slot type so we can have different kinds of jobs autoscale to different arrays.
default['htcondor']['slot_type'] = 'execute'

# DBC: if true, the schedulers have two schedds running. This should probably not be the default like this, but
# it is needed for backwards compatibility.
default['htcondor']['scheduler_dual'] = true

# Set the default lifetime of classads (in seconds). Longer times reduce the load on the collector
# but means it takes longer for terminated nodes to disappear from the pool.
default['htcondor']['classad_lifetime'] = 700

# Set the update interval for the startd (in seconds). Longer times reduce the load on the collector
# but means a slot might briefly disappear if it's too long.
default['htcondor']['update_interval'] = 240

# Set the minimum wait interval for autostop (in minutes).
# DEPRECATED: this attribute will be removed
default['htcondor']['autostop_wait'] = nil

# Should stopped nodes disappear from CycleServer?
default['htcondor']['remove_stopped_nodes'] = true

# Turn this off in general. For Master/Sub-Cluster pools where we need job submission to
# happen quickly consider turning this on. If it's on, CycleServer at the Master pool needs
# to be able to talk to port 8008 on every sub-pool's scheduler.
default['htcondor']['agent_enabled'] = false
default['htcondor']['agent_version'] = "1.27"

default['htcondor']['running'] = true

default['htcondor']['uid'] = 422
default['htcondor']['gid'] = 422

if node['os'] != "windows"
  default['htcondor']['condor_owner'] = "condor"
  default['htcondor']['condor_group'] = "cyclecloud"
end

default['htcondor']['install_dir'] = "/opt/condor"
if node['os'] == "windows"
  default['htcondor']['install_dir'] = "c:\\condor"
end

# use a volume with more space for logs and spool directories
default['htcondor']['data_dir'] = "/mnt/condor_data"
if node['os'] == "windows"
  # If nil, put the data_dir on first a reasonable volume and
  # symlink from C:\condor_local
  default['htcondor']['data_dir'] = nil
end

# Use Cycle Server to configure hosts. Currently only supported for Linux
# execute nodes. Once the proof-of-concept works correctly, we can expand
# support.
default['htcondor']['use_cache_config'] = false

# Configure execute nodes to advertise only a single slot
default['htcondor']['single_slot'] = false
# Configure execute nodes to advertise half of the CPUs (a poor man's way of disabling
# hyperthreading on Windows)
if node['os'] == "windows"
  default['htcondor']['ignore_hyperthreads'] = false
end

# Set the history log knobs. The target is to keep ~100k jobs in history
default['htcondor']['max_history_log'] = 20971520
default['htcondor']['max_history_rotations'] = 20

# Throttle the job starts to prevent the things from getting overwhelmed.
default['htcondor']['job_start_count'] = 20
default['htcondor']['job_start_delay'] = 1

# Build a custom config file with arbitrary attributes
default['htcondor']['custom_config']['enabled'] = false
default['htcondor']['custom_config']['file_name'] = 'ZZZ-custom_config.txt'

# This is set in cyclecloud legacy attributes
default['htcondor']['pool_password'] = "" if node['htcondor']['pool_password'].nil?
